// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.location;

/**
 * <p>
 * Représente un lieu au sens général du terme. Il peut s'agir d'un
 * lieu ponctuel, linéaire ou surfacique.
 * </p>
 * <p>
 * Suivant sa classification et son niveau, il peut s'agir d'un
 * secteur FAO, un port de pêche, un quartier maritime, une criée,
 * etc.
 * </p>
 * <p>
 * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 +
 * strates : 1000 + localités : 200
 * </p>
 */
public abstract class Location
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 302507620770234855L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant unique du lieu. Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String label;

    /**
     * <p>
     * Code du lieuExemple : pour les ports : BR, SB
     * </p>
     */
    public java.lang.String getLabel()
    {
        return this.label;
    }

    public void setLabel(java.lang.String label)
    {
        this.label = label;
    }

    private java.lang.String name;

    /**
     * <p>
     * Libellé du lieu
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }

    private java.lang.Float bathymetry;

    /**
     * <p>
     * Valeur de la bathymétrie sur le lieu (optionnel). La bathymétrie
     * peut être positive ou négative.
     * </p>
     */
    public java.lang.Float getBathymetry()
    {
        return this.bathymetry;
    }

    public void setBathymetry(java.lang.Float bathymetry)
    {
        this.bathymetry = bathymetry;
    }

    private java.lang.Short utFormat;

    /**
     * <p>
     * Format UT (Universal Time) de l'heure pour le lieu (0, +1,
     * -4...).
     * </p>
     * <p>
     * En France métropolitaine, par exemple : +1 (= heure
     * Europe/Paris)
     * </p>
     */
    public java.lang.Short getUtFormat()
    {
        return this.utFormat;
    }

    public void setUtFormat(java.lang.Short utFormat)
    {
        this.utFormat = utFormat;
    }

    private java.lang.Boolean daylightSavingTime;

    /**
     * <p>
     * Indique s'il faut opérer le changement d'heure hiver-été, vrai
     * par défaut.
     * </p>
     * <p>
     * En France métropolitaine, par exemple : Vrai.
     * </p>
     */
    public java.lang.Boolean getDaylightSavingTime()
    {
        return this.daylightSavingTime;
    }

    public void setDaylightSavingTime(java.lang.Boolean daylightSavingTime)
    {
        this.daylightSavingTime = daylightSavingTime;
    }




    private fr.ifremer.adagio.core.dao.referential.location.LocationLevel locationLevel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.location.LocationLevel getLocationLevel()
    {
        return this.locationLevel;
    }

    public void setLocationLevel(fr.ifremer.adagio.core.dao.referential.location.LocationLevel locationLevel)
    {
        this.locationLevel = locationLevel;
    }




    private fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.location.LocationClassification getLocationClassification()
    {
        return this.locationClassification;
    }

    public void setLocationClassification(fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification)
    {
        this.locationClassification = locationClassification;
    }


    private fr.ifremer.adagio.core.dao.referential.Status status;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.Status getStatus()
    {
        return this.status;
    }

    public void setStatus(fr.ifremer.adagio.core.dao.referential.Status status)
    {
        this.status = status;
    }




































    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Location))
        {
            return false;
        }
        final Location that = (Location)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.location.Location}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.location.Location}.
         */
        public static fr.ifremer.adagio.core.dao.referential.location.Location newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.location.Location entity = new fr.ifremer.adagio.core.dao.referential.location.LocationImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.location.Location}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.location.Location newInstance(java.lang.String name, fr.ifremer.adagio.core.dao.referential.location.LocationLevel locationLevel, fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.location.Location entity = newInstance();
            entity.setName(name);
            entity.setLocationLevel(locationLevel);
            entity.setLocationClassification(locationClassification);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.location.Location}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.location.Location newInstance(java.lang.String label, java.lang.String name, java.sql.Timestamp updateDate, java.lang.Float bathymetry, java.lang.Short utFormat, java.lang.Boolean daylightSavingTime, fr.ifremer.adagio.core.dao.referential.location.LocationLevel locationLevel, fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.location.Location entity = newInstance();
            entity.setLabel(label);
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setBathymetry(bathymetry);
            entity.setUtFormat(utFormat);
            entity.setDaylightSavingTime(daylightSavingTime);
            entity.setLocationLevel(locationLevel);
            entity.setLocationClassification(locationClassification);
            entity.setStatus(status);
            return entity;
        }
    }
    
// Location.java merge-point
}